Subject: Re: [PATCH] brouted packet identified as PACKET_OTHERHOST blocked by higher protocol

From: Florian Westphal <[email-masked]>
Date: Tue, 14 Jul 2015 13:59:49 +0200

Yigal Reiss (yreiss) <[email-masked]> wrote:
> Florian Westphal [mailto:[email-masked]] wrote:
> > Maybe, but if you broute everything you might as well just remove the
> > bridge...
> I want to be selective. My setup is a home router. So I can have ebtables rules for 
> which traffic to (b)route and which to bridge, based on security/performance criteria.

This usually doesn't work since you can only safely use L3 headers
(unless you disallow ip fragmentation to occur -- else first fragment
 will be brouted, rest is bridged).

> > You can use -j redirect in ebtables broute table to force local MAC dnat
> > (this also 'fixes' the pkttype to _HOST) if you really want to broute.
> I may be missing something obvious, but what is the normal case where using an 
> ebtables 'broute' "-j DROP" rule does work?

It doesn't, (for ip protocols), as you discovered.
But there are other protocols too, so I'm not sure its good idea to
uncoditionally reset pkttype.

(It also changes long-standing behaviour).

Note that broute only "works" in some cases, such as brouting a specific
host.

'Sometimes bridged, sometimes routed' usually causes various issues,
such as ip addresses seemingly 'moving' to different host.

> What is the original intention of this table/chain if not pulling packets between 
> "other hosts" out of the bridge and passing them through the IP and higher layers?

No idea, I did not add this feature.